
package org.dmg.pmml;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="type" use="required">
 *         &lt;simpleType>
 *           &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *             &lt;enumeration value="Model"/>
 *             &lt;enumeration value="Error"/>
 *             &lt;enumeration value="Total"/>
 *           &lt;/restriction>
 *         &lt;/simpleType>
 *       &lt;/attribute>
 *       &lt;attribute name="sumOfSquares" use="required" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="degreesOfFreedom" use="required" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="meanOfSquares" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="fValue" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="pValue" type="{http://www.dmg.org/PMML-4_1}PROB-NUMBER" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions"
})
@XmlRootElement(name = "AnovaRow")
@Schema(min = Version.PMML_4_0)
public class AnovaRow
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlAttribute(name = "type", required = true)
    protected String type;
    @XmlAttribute(name = "sumOfSquares", required = true)
    protected double sumOfSquares;
    @XmlAttribute(name = "degreesOfFreedom", required = true)
    protected double degreesOfFreedom;
    @XmlAttribute(name = "meanOfSquares")
    protected Double meanOfSquares;
    @XmlAttribute(name = "fValue")
    protected Double fValue;
    @XmlAttribute(name = "pValue")
    protected BigDecimal pValue;

    @Deprecated
    public AnovaRow() {
        super();
    }

    public AnovaRow(final String type, final double sumOfSquares, final double degreesOfFreedom) {
        super();
        this.type = type;
        this.sumOfSquares = sumOfSquares;
        this.degreesOfFreedom = degreesOfFreedom;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the type property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getType() {
        return type;
    }

    /**
     * Sets the value of the type property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setType(String value) {
        this.type = value;
    }

    /**
     * Gets the value of the sumOfSquares property.
     * 
     */
    public double getSumOfSquares() {
        return sumOfSquares;
    }

    /**
     * Sets the value of the sumOfSquares property.
     * 
     */
    public void setSumOfSquares(double value) {
        this.sumOfSquares = value;
    }

    /**
     * Gets the value of the degreesOfFreedom property.
     * 
     */
    public double getDegreesOfFreedom() {
        return degreesOfFreedom;
    }

    /**
     * Sets the value of the degreesOfFreedom property.
     * 
     */
    public void setDegreesOfFreedom(double value) {
        this.degreesOfFreedom = value;
    }

    /**
     * Gets the value of the meanOfSquares property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getMeanOfSquares() {
        return meanOfSquares;
    }

    /**
     * Sets the value of the meanOfSquares property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setMeanOfSquares(Double value) {
        this.meanOfSquares = value;
    }

    /**
     * Gets the value of the fValue property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getFValue() {
        return fValue;
    }

    /**
     * Sets the value of the fValue property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setFValue(Double value) {
        this.fValue = value;
    }

    /**
     * Gets the value of the pValue property.
     * 
     * @return
     *     possible object is
     *     {@link BigDecimal }
     *     
     */
    public BigDecimal getPValue() {
        return pValue;
    }

    /**
     * Sets the value of the pValue property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigDecimal }
     *     
     */
    public void setPValue(BigDecimal value) {
        this.pValue = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof AnovaRow)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final AnovaRow that = ((AnovaRow) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            String lhsType;
            lhsType = this.getType();
            String rhsType;
            rhsType = that.getType();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "type", lhsType), LocatorUtils.property(thatLocator, "type", rhsType), lhsType, rhsType)) {
                return false;
            }
        }
        {
            double lhsSumOfSquares;
            lhsSumOfSquares = (true?this.getSumOfSquares(): 0.0D);
            double rhsSumOfSquares;
            rhsSumOfSquares = (true?that.getSumOfSquares(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "sumOfSquares", lhsSumOfSquares), LocatorUtils.property(thatLocator, "sumOfSquares", rhsSumOfSquares), lhsSumOfSquares, rhsSumOfSquares)) {
                return false;
            }
        }
        {
            double lhsDegreesOfFreedom;
            lhsDegreesOfFreedom = (true?this.getDegreesOfFreedom(): 0.0D);
            double rhsDegreesOfFreedom;
            rhsDegreesOfFreedom = (true?that.getDegreesOfFreedom(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "degreesOfFreedom", lhsDegreesOfFreedom), LocatorUtils.property(thatLocator, "degreesOfFreedom", rhsDegreesOfFreedom), lhsDegreesOfFreedom, rhsDegreesOfFreedom)) {
                return false;
            }
        }
        {
            Double lhsMeanOfSquares;
            lhsMeanOfSquares = this.getMeanOfSquares();
            Double rhsMeanOfSquares;
            rhsMeanOfSquares = that.getMeanOfSquares();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "meanOfSquares", lhsMeanOfSquares), LocatorUtils.property(thatLocator, "meanOfSquares", rhsMeanOfSquares), lhsMeanOfSquares, rhsMeanOfSquares)) {
                return false;
            }
        }
        {
            Double lhsFValue;
            lhsFValue = this.getFValue();
            Double rhsFValue;
            rhsFValue = that.getFValue();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "fValue", lhsFValue), LocatorUtils.property(thatLocator, "fValue", rhsFValue), lhsFValue, rhsFValue)) {
                return false;
            }
        }
        {
            BigDecimal lhsPValue;
            lhsPValue = this.getPValue();
            BigDecimal rhsPValue;
            rhsPValue = that.getPValue();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "pValue", lhsPValue), LocatorUtils.property(thatLocator, "pValue", rhsPValue), lhsPValue, rhsPValue)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            String theType;
            theType = this.getType();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "type", theType), currentHashCode, theType);
        }
        {
            double theSumOfSquares;
            theSumOfSquares = (true?this.getSumOfSquares(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "sumOfSquares", theSumOfSquares), currentHashCode, theSumOfSquares);
        }
        {
            double theDegreesOfFreedom;
            theDegreesOfFreedom = (true?this.getDegreesOfFreedom(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "degreesOfFreedom", theDegreesOfFreedom), currentHashCode, theDegreesOfFreedom);
        }
        {
            Double theMeanOfSquares;
            theMeanOfSquares = this.getMeanOfSquares();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "meanOfSquares", theMeanOfSquares), currentHashCode, theMeanOfSquares);
        }
        {
            Double theFValue;
            theFValue = this.getFValue();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "fValue", theFValue), currentHashCode, theFValue);
        }
        {
            BigDecimal thePValue;
            thePValue = this.getPValue();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "pValue", thePValue), currentHashCode, thePValue);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            String theType;
            theType = this.getType();
            strategy.appendField(locator, this, "type", buffer, theType);
        }
        {
            double theSumOfSquares;
            theSumOfSquares = (true?this.getSumOfSquares(): 0.0D);
            strategy.appendField(locator, this, "sumOfSquares", buffer, theSumOfSquares);
        }
        {
            double theDegreesOfFreedom;
            theDegreesOfFreedom = (true?this.getDegreesOfFreedom(): 0.0D);
            strategy.appendField(locator, this, "degreesOfFreedom", buffer, theDegreesOfFreedom);
        }
        {
            Double theMeanOfSquares;
            theMeanOfSquares = this.getMeanOfSquares();
            strategy.appendField(locator, this, "meanOfSquares", buffer, theMeanOfSquares);
        }
        {
            Double theFValue;
            theFValue = this.getFValue();
            strategy.appendField(locator, this, "fValue", buffer, theFValue);
        }
        {
            BigDecimal thePValue;
            thePValue = this.getPValue();
            strategy.appendField(locator, this, "pValue", buffer, thePValue);
        }
        return buffer;
    }

}
