
package org.dmg.pmml;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="name" use="required" type="{http://www.dmg.org/PMML-4_1}FIELD-NAME" />
 *       &lt;attribute name="usageType" type="{http://www.dmg.org/PMML-4_1}FIELD-USAGE-TYPE" default="active" />
 *       &lt;attribute name="optype" type="{http://www.dmg.org/PMML-4_1}OPTYPE" />
 *       &lt;attribute name="importance" type="{http://www.dmg.org/PMML-4_1}PROB-NUMBER" />
 *       &lt;attribute name="outliers" type="{http://www.dmg.org/PMML-4_1}OUTLIER-TREATMENT-METHOD" default="asIs" />
 *       &lt;attribute name="lowValue" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="highValue" type="{http://www.dmg.org/PMML-4_1}NUMBER" />
 *       &lt;attribute name="missingValueReplacement" type="{http://www.w3.org/2001/XMLSchema}string" />
 *       &lt;attribute name="missingValueTreatment" type="{http://www.dmg.org/PMML-4_1}MISSING-VALUE-TREATMENT-METHOD" />
 *       &lt;attribute name="invalidValueTreatment" type="{http://www.dmg.org/PMML-4_1}INVALID-VALUE-TREATMENT-METHOD" default="returnInvalid" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions"
})
@XmlRootElement(name = "MiningField")
public class MiningField
    extends Field
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlAttribute(name = "name", required = true)
    protected FieldName name;
    @XmlAttribute(name = "usageType")
    protected FieldUsageType usageType;
    @XmlAttribute(name = "optype")
    protected OpType optype;
    @XmlAttribute(name = "importance")
    protected BigDecimal importance;
    @XmlAttribute(name = "outliers")
    protected OutlierTreatmentMethodType outliers;
    @XmlAttribute(name = "lowValue")
    protected Double lowValue;
    @XmlAttribute(name = "highValue")
    protected Double highValue;
    @XmlAttribute(name = "missingValueReplacement")
    protected String missingValueReplacement;
    @XmlAttribute(name = "missingValueTreatment")
    protected MissingValueTreatmentMethodType missingValueTreatment;
    @XmlAttribute(name = "invalidValueTreatment")
    protected InvalidValueTreatmentMethodType invalidValueTreatment;

    @Deprecated
    public MiningField() {
        super();
    }

    public MiningField(final FieldName name) {
        super();
        this.name = name;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the name property.
     * 
     * @return
     *     possible object is
     *     {@link FieldName }
     *     
     */
    public FieldName getName() {
        return name;
    }

    /**
     * Sets the value of the name property.
     * 
     * @param value
     *     allowed object is
     *     {@link FieldName }
     *     
     */
    public void setName(FieldName value) {
        this.name = value;
    }

    /**
     * Gets the value of the usageType property.
     * 
     * @return
     *     possible object is
     *     {@link FieldUsageType }
     *     
     */
    public FieldUsageType getUsageType() {
        if (usageType == null) {
            return FieldUsageType.ACTIVE;
        } else {
            return usageType;
        }
    }

    /**
     * Sets the value of the usageType property.
     * 
     * @param value
     *     allowed object is
     *     {@link FieldUsageType }
     *     
     */
    public void setUsageType(FieldUsageType value) {
        this.usageType = value;
    }

    /**
     * Gets the value of the optype property.
     * 
     * @return
     *     possible object is
     *     {@link OpType }
     *     
     */
    public OpType getOptype() {
        return optype;
    }

    /**
     * Sets the value of the optype property.
     * 
     * @param value
     *     allowed object is
     *     {@link OpType }
     *     
     */
    public void setOptype(OpType value) {
        this.optype = value;
    }

    /**
     * Gets the value of the importance property.
     * 
     * @return
     *     possible object is
     *     {@link BigDecimal }
     *     
     */
    public BigDecimal getImportance() {
        return importance;
    }

    /**
     * Sets the value of the importance property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigDecimal }
     *     
     */
    public void setImportance(BigDecimal value) {
        this.importance = value;
    }

    /**
     * Gets the value of the outliers property.
     * 
     * @return
     *     possible object is
     *     {@link OutlierTreatmentMethodType }
     *     
     */
    public OutlierTreatmentMethodType getOutliers() {
        if (outliers == null) {
            return OutlierTreatmentMethodType.AS_IS;
        } else {
            return outliers;
        }
    }

    /**
     * Sets the value of the outliers property.
     * 
     * @param value
     *     allowed object is
     *     {@link OutlierTreatmentMethodType }
     *     
     */
    public void setOutliers(OutlierTreatmentMethodType value) {
        this.outliers = value;
    }

    /**
     * Gets the value of the lowValue property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getLowValue() {
        return lowValue;
    }

    /**
     * Sets the value of the lowValue property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setLowValue(Double value) {
        this.lowValue = value;
    }

    /**
     * Gets the value of the highValue property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getHighValue() {
        return highValue;
    }

    /**
     * Sets the value of the highValue property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setHighValue(Double value) {
        this.highValue = value;
    }

    /**
     * Gets the value of the missingValueReplacement property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getMissingValueReplacement() {
        return missingValueReplacement;
    }

    /**
     * Sets the value of the missingValueReplacement property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setMissingValueReplacement(String value) {
        this.missingValueReplacement = value;
    }

    /**
     * Gets the value of the missingValueTreatment property.
     * 
     * @return
     *     possible object is
     *     {@link MissingValueTreatmentMethodType }
     *     
     */
    public MissingValueTreatmentMethodType getMissingValueTreatment() {
        return missingValueTreatment;
    }

    /**
     * Sets the value of the missingValueTreatment property.
     * 
     * @param value
     *     allowed object is
     *     {@link MissingValueTreatmentMethodType }
     *     
     */
    public void setMissingValueTreatment(MissingValueTreatmentMethodType value) {
        this.missingValueTreatment = value;
    }

    /**
     * Gets the value of the invalidValueTreatment property.
     * 
     * @return
     *     possible object is
     *     {@link InvalidValueTreatmentMethodType }
     *     
     */
    public InvalidValueTreatmentMethodType getInvalidValueTreatment() {
        if (invalidValueTreatment == null) {
            return InvalidValueTreatmentMethodType.RETURN_INVALID;
        } else {
            return invalidValueTreatment;
        }
    }

    /**
     * Sets the value of the invalidValueTreatment property.
     * 
     * @param value
     *     allowed object is
     *     {@link InvalidValueTreatmentMethodType }
     *     
     */
    public void setInvalidValueTreatment(InvalidValueTreatmentMethodType value) {
        this.invalidValueTreatment = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof MiningField)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final MiningField that = ((MiningField) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            FieldName lhsName;
            lhsName = this.getName();
            FieldName rhsName;
            rhsName = that.getName();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "name", lhsName), LocatorUtils.property(thatLocator, "name", rhsName), lhsName, rhsName)) {
                return false;
            }
        }
        {
            FieldUsageType lhsUsageType;
            lhsUsageType = this.getUsageType();
            FieldUsageType rhsUsageType;
            rhsUsageType = that.getUsageType();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "usageType", lhsUsageType), LocatorUtils.property(thatLocator, "usageType", rhsUsageType), lhsUsageType, rhsUsageType)) {
                return false;
            }
        }
        {
            OpType lhsOptype;
            lhsOptype = this.getOptype();
            OpType rhsOptype;
            rhsOptype = that.getOptype();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "optype", lhsOptype), LocatorUtils.property(thatLocator, "optype", rhsOptype), lhsOptype, rhsOptype)) {
                return false;
            }
        }
        {
            BigDecimal lhsImportance;
            lhsImportance = this.getImportance();
            BigDecimal rhsImportance;
            rhsImportance = that.getImportance();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "importance", lhsImportance), LocatorUtils.property(thatLocator, "importance", rhsImportance), lhsImportance, rhsImportance)) {
                return false;
            }
        }
        {
            OutlierTreatmentMethodType lhsOutliers;
            lhsOutliers = this.getOutliers();
            OutlierTreatmentMethodType rhsOutliers;
            rhsOutliers = that.getOutliers();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "outliers", lhsOutliers), LocatorUtils.property(thatLocator, "outliers", rhsOutliers), lhsOutliers, rhsOutliers)) {
                return false;
            }
        }
        {
            Double lhsLowValue;
            lhsLowValue = this.getLowValue();
            Double rhsLowValue;
            rhsLowValue = that.getLowValue();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "lowValue", lhsLowValue), LocatorUtils.property(thatLocator, "lowValue", rhsLowValue), lhsLowValue, rhsLowValue)) {
                return false;
            }
        }
        {
            Double lhsHighValue;
            lhsHighValue = this.getHighValue();
            Double rhsHighValue;
            rhsHighValue = that.getHighValue();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "highValue", lhsHighValue), LocatorUtils.property(thatLocator, "highValue", rhsHighValue), lhsHighValue, rhsHighValue)) {
                return false;
            }
        }
        {
            String lhsMissingValueReplacement;
            lhsMissingValueReplacement = this.getMissingValueReplacement();
            String rhsMissingValueReplacement;
            rhsMissingValueReplacement = that.getMissingValueReplacement();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "missingValueReplacement", lhsMissingValueReplacement), LocatorUtils.property(thatLocator, "missingValueReplacement", rhsMissingValueReplacement), lhsMissingValueReplacement, rhsMissingValueReplacement)) {
                return false;
            }
        }
        {
            MissingValueTreatmentMethodType lhsMissingValueTreatment;
            lhsMissingValueTreatment = this.getMissingValueTreatment();
            MissingValueTreatmentMethodType rhsMissingValueTreatment;
            rhsMissingValueTreatment = that.getMissingValueTreatment();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "missingValueTreatment", lhsMissingValueTreatment), LocatorUtils.property(thatLocator, "missingValueTreatment", rhsMissingValueTreatment), lhsMissingValueTreatment, rhsMissingValueTreatment)) {
                return false;
            }
        }
        {
            InvalidValueTreatmentMethodType lhsInvalidValueTreatment;
            lhsInvalidValueTreatment = this.getInvalidValueTreatment();
            InvalidValueTreatmentMethodType rhsInvalidValueTreatment;
            rhsInvalidValueTreatment = that.getInvalidValueTreatment();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "invalidValueTreatment", lhsInvalidValueTreatment), LocatorUtils.property(thatLocator, "invalidValueTreatment", rhsInvalidValueTreatment), lhsInvalidValueTreatment, rhsInvalidValueTreatment)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            FieldName theName;
            theName = this.getName();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "name", theName), currentHashCode, theName);
        }
        {
            FieldUsageType theUsageType;
            theUsageType = this.getUsageType();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "usageType", theUsageType), currentHashCode, theUsageType);
        }
        {
            OpType theOptype;
            theOptype = this.getOptype();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "optype", theOptype), currentHashCode, theOptype);
        }
        {
            BigDecimal theImportance;
            theImportance = this.getImportance();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "importance", theImportance), currentHashCode, theImportance);
        }
        {
            OutlierTreatmentMethodType theOutliers;
            theOutliers = this.getOutliers();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "outliers", theOutliers), currentHashCode, theOutliers);
        }
        {
            Double theLowValue;
            theLowValue = this.getLowValue();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "lowValue", theLowValue), currentHashCode, theLowValue);
        }
        {
            Double theHighValue;
            theHighValue = this.getHighValue();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "highValue", theHighValue), currentHashCode, theHighValue);
        }
        {
            String theMissingValueReplacement;
            theMissingValueReplacement = this.getMissingValueReplacement();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "missingValueReplacement", theMissingValueReplacement), currentHashCode, theMissingValueReplacement);
        }
        {
            MissingValueTreatmentMethodType theMissingValueTreatment;
            theMissingValueTreatment = this.getMissingValueTreatment();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "missingValueTreatment", theMissingValueTreatment), currentHashCode, theMissingValueTreatment);
        }
        {
            InvalidValueTreatmentMethodType theInvalidValueTreatment;
            theInvalidValueTreatment = this.getInvalidValueTreatment();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "invalidValueTreatment", theInvalidValueTreatment), currentHashCode, theInvalidValueTreatment);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            FieldName theName;
            theName = this.getName();
            strategy.appendField(locator, this, "name", buffer, theName);
        }
        {
            FieldUsageType theUsageType;
            theUsageType = this.getUsageType();
            strategy.appendField(locator, this, "usageType", buffer, theUsageType);
        }
        {
            OpType theOptype;
            theOptype = this.getOptype();
            strategy.appendField(locator, this, "optype", buffer, theOptype);
        }
        {
            BigDecimal theImportance;
            theImportance = this.getImportance();
            strategy.appendField(locator, this, "importance", buffer, theImportance);
        }
        {
            OutlierTreatmentMethodType theOutliers;
            theOutliers = this.getOutliers();
            strategy.appendField(locator, this, "outliers", buffer, theOutliers);
        }
        {
            Double theLowValue;
            theLowValue = this.getLowValue();
            strategy.appendField(locator, this, "lowValue", buffer, theLowValue);
        }
        {
            Double theHighValue;
            theHighValue = this.getHighValue();
            strategy.appendField(locator, this, "highValue", buffer, theHighValue);
        }
        {
            String theMissingValueReplacement;
            theMissingValueReplacement = this.getMissingValueReplacement();
            strategy.appendField(locator, this, "missingValueReplacement", buffer, theMissingValueReplacement);
        }
        {
            MissingValueTreatmentMethodType theMissingValueTreatment;
            theMissingValueTreatment = this.getMissingValueTreatment();
            strategy.appendField(locator, this, "missingValueTreatment", buffer, theMissingValueTreatment);
        }
        {
            InvalidValueTreatmentMethodType theInvalidValueTreatment;
            theInvalidValueTreatment = this.getInvalidValueTreatment();
            strategy.appendField(locator, this, "invalidValueTreatment", buffer, theInvalidValueTreatment);
        }
        return buffer;
    }

}
