
package org.dmg.pmml;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}AntecedentSequence"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Delimiter"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Time" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}ConsequentSequence"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Time" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="id" use="required" type="{http://www.dmg.org/PMML-4_1}ELEMENT-ID" />
 *       &lt;attribute name="numberOfSets" use="required" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" />
 *       &lt;attribute name="occurrence" use="required" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" />
 *       &lt;attribute name="support" use="required" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="confidence" use="required" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *       &lt;attribute name="lift" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "extensions",
    "content"
})
@XmlRootElement(name = "SequenceRule")
public class SequenceRule
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlElementRefs({
        @XmlElementRef(name = "Delimiter", namespace = "http://www.dmg.org/PMML-4_1", type = Delimiter.class),
        @XmlElementRef(name = "AntecedentSequence", namespace = "http://www.dmg.org/PMML-4_1", type = AntecedentSequence.class),
        @XmlElementRef(name = "Time", namespace = "http://www.dmg.org/PMML-4_1", type = Time.class),
        @XmlElementRef(name = "ConsequentSequence", namespace = "http://www.dmg.org/PMML-4_1", type = ConsequentSequence.class)
    })
    protected List<PMMLObject> content;
    @XmlAttribute(name = "id", required = true)
    protected ElementId id;
    @XmlAttribute(name = "numberOfSets", required = true)
    protected BigInteger numberOfSets;
    @XmlAttribute(name = "occurrence", required = true)
    protected BigInteger occurrence;
    @XmlAttribute(name = "support", required = true)
    protected double support;
    @XmlAttribute(name = "confidence", required = true)
    protected double confidence;
    @XmlAttribute(name = "lift")
    protected Double lift;

    @Deprecated
    public SequenceRule() {
        super();
    }

    public SequenceRule(final ElementId id, final BigInteger numberOfSets, final BigInteger occurrence, final double support, final double confidence) {
        super();
        this.id = id;
        this.numberOfSets = numberOfSets;
        this.occurrence = occurrence;
        this.support = support;
        this.confidence = confidence;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the rest of the content model. 
     * 
     * <p>
     * You are getting this "catch-all" property because of the following reason: 
     * The field name "Time" is used by two different parts of a schema. See: 
     * line 2355 of file:/P:/jpmml/jpmml/target/checkout/pmml-model/target/transformed-schema/pmml.xsd
     * line 2353 of file:/P:/jpmml/jpmml/target/checkout/pmml-model/target/transformed-schema/pmml.xsd
     * <p>
     * To get rid of this property, apply a property customization to one 
     * of both of the following declarations to change their names: 
     * Gets the value of the content property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the content property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getContent().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Delimiter }
     * {@link Time }
     * {@link AntecedentSequence }
     * {@link ConsequentSequence }
     * 
     * 
     */
    public List<PMMLObject> getContent() {
        if (content == null) {
            content = new ArrayList<PMMLObject>();
        }
        return this.content;
    }

    /**
     * Gets the value of the id property.
     * 
     * @return
     *     possible object is
     *     {@link ElementId }
     *     
     */
    public ElementId getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     * 
     * @param value
     *     allowed object is
     *     {@link ElementId }
     *     
     */
    public void setId(ElementId value) {
        this.id = value;
    }

    /**
     * Gets the value of the numberOfSets property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getNumberOfSets() {
        return numberOfSets;
    }

    /**
     * Sets the value of the numberOfSets property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setNumberOfSets(BigInteger value) {
        this.numberOfSets = value;
    }

    /**
     * Gets the value of the occurrence property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getOccurrence() {
        return occurrence;
    }

    /**
     * Sets the value of the occurrence property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setOccurrence(BigInteger value) {
        this.occurrence = value;
    }

    /**
     * Gets the value of the support property.
     * 
     */
    public double getSupport() {
        return support;
    }

    /**
     * Sets the value of the support property.
     * 
     */
    public void setSupport(double value) {
        this.support = value;
    }

    /**
     * Gets the value of the confidence property.
     * 
     */
    public double getConfidence() {
        return confidence;
    }

    /**
     * Sets the value of the confidence property.
     * 
     */
    public void setConfidence(double value) {
        this.confidence = value;
    }

    /**
     * Gets the value of the lift property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public Double getLift() {
        return lift;
    }

    /**
     * Sets the value of the lift property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setLift(Double value) {
        this.lift = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof SequenceRule)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final SequenceRule that = ((SequenceRule) object);
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            List<PMMLObject> lhsContent;
            lhsContent = (((this.content!= null)&&(!this.content.isEmpty()))?this.getContent():null);
            List<PMMLObject> rhsContent;
            rhsContent = (((that.content!= null)&&(!that.content.isEmpty()))?that.getContent():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "content", lhsContent), LocatorUtils.property(thatLocator, "content", rhsContent), lhsContent, rhsContent)) {
                return false;
            }
        }
        {
            ElementId lhsId;
            lhsId = this.getId();
            ElementId rhsId;
            rhsId = that.getId();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "id", lhsId), LocatorUtils.property(thatLocator, "id", rhsId), lhsId, rhsId)) {
                return false;
            }
        }
        {
            BigInteger lhsNumberOfSets;
            lhsNumberOfSets = this.getNumberOfSets();
            BigInteger rhsNumberOfSets;
            rhsNumberOfSets = that.getNumberOfSets();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "numberOfSets", lhsNumberOfSets), LocatorUtils.property(thatLocator, "numberOfSets", rhsNumberOfSets), lhsNumberOfSets, rhsNumberOfSets)) {
                return false;
            }
        }
        {
            BigInteger lhsOccurrence;
            lhsOccurrence = this.getOccurrence();
            BigInteger rhsOccurrence;
            rhsOccurrence = that.getOccurrence();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "occurrence", lhsOccurrence), LocatorUtils.property(thatLocator, "occurrence", rhsOccurrence), lhsOccurrence, rhsOccurrence)) {
                return false;
            }
        }
        {
            double lhsSupport;
            lhsSupport = (true?this.getSupport(): 0.0D);
            double rhsSupport;
            rhsSupport = (true?that.getSupport(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "support", lhsSupport), LocatorUtils.property(thatLocator, "support", rhsSupport), lhsSupport, rhsSupport)) {
                return false;
            }
        }
        {
            double lhsConfidence;
            lhsConfidence = (true?this.getConfidence(): 0.0D);
            double rhsConfidence;
            rhsConfidence = (true?that.getConfidence(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "confidence", lhsConfidence), LocatorUtils.property(thatLocator, "confidence", rhsConfidence), lhsConfidence, rhsConfidence)) {
                return false;
            }
        }
        {
            Double lhsLift;
            lhsLift = this.getLift();
            Double rhsLift;
            rhsLift = that.getLift();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "lift", lhsLift), LocatorUtils.property(thatLocator, "lift", rhsLift), lhsLift, rhsLift)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            List<PMMLObject> theContent;
            theContent = (((this.content!= null)&&(!this.content.isEmpty()))?this.getContent():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "content", theContent), currentHashCode, theContent);
        }
        {
            ElementId theId;
            theId = this.getId();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "id", theId), currentHashCode, theId);
        }
        {
            BigInteger theNumberOfSets;
            theNumberOfSets = this.getNumberOfSets();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "numberOfSets", theNumberOfSets), currentHashCode, theNumberOfSets);
        }
        {
            BigInteger theOccurrence;
            theOccurrence = this.getOccurrence();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "occurrence", theOccurrence), currentHashCode, theOccurrence);
        }
        {
            double theSupport;
            theSupport = (true?this.getSupport(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "support", theSupport), currentHashCode, theSupport);
        }
        {
            double theConfidence;
            theConfidence = (true?this.getConfidence(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "confidence", theConfidence), currentHashCode, theConfidence);
        }
        {
            Double theLift;
            theLift = this.getLift();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "lift", theLift), currentHashCode, theLift);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            List<PMMLObject> theContent;
            theContent = (((this.content!= null)&&(!this.content.isEmpty()))?this.getContent():null);
            strategy.appendField(locator, this, "content", buffer, theContent);
        }
        {
            ElementId theId;
            theId = this.getId();
            strategy.appendField(locator, this, "id", buffer, theId);
        }
        {
            BigInteger theNumberOfSets;
            theNumberOfSets = this.getNumberOfSets();
            strategy.appendField(locator, this, "numberOfSets", buffer, theNumberOfSets);
        }
        {
            BigInteger theOccurrence;
            theOccurrence = this.getOccurrence();
            strategy.appendField(locator, this, "occurrence", buffer, theOccurrence);
        }
        {
            double theSupport;
            theSupport = (true?this.getSupport(): 0.0D);
            strategy.appendField(locator, this, "support", buffer, theSupport);
        }
        {
            double theConfidence;
            theConfidence = (true?this.getConfidence(): 0.0D);
            strategy.appendField(locator, this, "confidence", buffer, theConfidence);
        }
        {
            Double theLift;
            theLift = this.getLift();
            strategy.appendField(locator, this, "lift", buffer, theLift);
        }
        return buffer;
    }

}
