
package org.dmg.pmml;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Baseline"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Alternate" minOccurs="0"/>
 *         &lt;element ref="{http://www.dmg.org/PMML-4_1}Extension" maxOccurs="unbounded" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="field" use="required" type="{http://www.dmg.org/PMML-4_1}FIELD-NAME" />
 *       &lt;attribute name="testStatistic" use="required" type="{http://www.dmg.org/PMML-4_1}BASELINE-TEST-STATISTIC" />
 *       &lt;attribute name="resetValue" type="{http://www.dmg.org/PMML-4_1}REAL-NUMBER" default="0.0" />
 *       &lt;attribute name="windowSize" type="{http://www.dmg.org/PMML-4_1}INT-NUMBER" default="0" />
 *       &lt;attribute name="weightField" type="{http://www.dmg.org/PMML-4_1}FIELD-NAME" />
 *       &lt;attribute name="normalizationScheme" type="{http://www.w3.org/2001/XMLSchema}string" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "baseline",
    "alternate",
    "extensions"
})
@XmlRootElement(name = "TestDistributions")
@Schema(min = Version.PMML_4_1)
public class TestDistributions
    extends PMMLObject
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "Baseline", required = true)
    protected Baseline baseline;
    @XmlElement(name = "Alternate")
    protected Alternate alternate;
    @XmlElement(name = "Extension")
    protected List<Extension> extensions;
    @XmlAttribute(name = "field", required = true)
    protected FieldName field;
    @XmlAttribute(name = "testStatistic", required = true)
    protected BaselineTestStatisticType testStatistic;
    @XmlAttribute(name = "resetValue")
    protected Double resetValue;
    @XmlAttribute(name = "windowSize")
    protected BigInteger windowSize;
    @XmlAttribute(name = "weightField")
    protected FieldName weightField;
    @XmlAttribute(name = "normalizationScheme")
    protected String normalizationScheme;

    @Deprecated
    public TestDistributions() {
        super();
    }

    public TestDistributions(final Baseline baseline, final FieldName field, final BaselineTestStatisticType testStatistic) {
        super();
        this.baseline = baseline;
        this.field = field;
        this.testStatistic = testStatistic;
    }

    /**
     * Gets the value of the baseline property.
     * 
     * @return
     *     possible object is
     *     {@link Baseline }
     *     
     */
    public Baseline getBaseline() {
        return baseline;
    }

    /**
     * Sets the value of the baseline property.
     * 
     * @param value
     *     allowed object is
     *     {@link Baseline }
     *     
     */
    public void setBaseline(Baseline value) {
        this.baseline = value;
    }

    /**
     * Gets the value of the alternate property.
     * 
     * @return
     *     possible object is
     *     {@link Alternate }
     *     
     */
    public Alternate getAlternate() {
        return alternate;
    }

    /**
     * Sets the value of the alternate property.
     * 
     * @param value
     *     allowed object is
     *     {@link Alternate }
     *     
     */
    public void setAlternate(Alternate value) {
        this.alternate = value;
    }

    /**
     * Gets the value of the extensions property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the extensions property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getExtensions().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Extension }
     * 
     * 
     */
    public List<Extension> getExtensions() {
        if (extensions == null) {
            extensions = new ArrayList<Extension>();
        }
        return this.extensions;
    }

    /**
     * Gets the value of the field property.
     * 
     * @return
     *     possible object is
     *     {@link FieldName }
     *     
     */
    public FieldName getField() {
        return field;
    }

    /**
     * Sets the value of the field property.
     * 
     * @param value
     *     allowed object is
     *     {@link FieldName }
     *     
     */
    public void setField(FieldName value) {
        this.field = value;
    }

    /**
     * Gets the value of the testStatistic property.
     * 
     * @return
     *     possible object is
     *     {@link BaselineTestStatisticType }
     *     
     */
    public BaselineTestStatisticType getTestStatistic() {
        return testStatistic;
    }

    /**
     * Sets the value of the testStatistic property.
     * 
     * @param value
     *     allowed object is
     *     {@link BaselineTestStatisticType }
     *     
     */
    public void setTestStatistic(BaselineTestStatisticType value) {
        this.testStatistic = value;
    }

    /**
     * Gets the value of the resetValue property.
     * 
     * @return
     *     possible object is
     *     {@link Double }
     *     
     */
    public double getResetValue() {
        if (resetValue == null) {
            return  0.0D;
        } else {
            return resetValue;
        }
    }

    /**
     * Sets the value of the resetValue property.
     * 
     * @param value
     *     allowed object is
     *     {@link Double }
     *     
     */
    public void setResetValue(Double value) {
        this.resetValue = value;
    }

    /**
     * Gets the value of the windowSize property.
     * 
     * @return
     *     possible object is
     *     {@link BigInteger }
     *     
     */
    public BigInteger getWindowSize() {
        if (windowSize == null) {
            return new BigInteger("0");
        } else {
            return windowSize;
        }
    }

    /**
     * Sets the value of the windowSize property.
     * 
     * @param value
     *     allowed object is
     *     {@link BigInteger }
     *     
     */
    public void setWindowSize(BigInteger value) {
        this.windowSize = value;
    }

    /**
     * Gets the value of the weightField property.
     * 
     * @return
     *     possible object is
     *     {@link FieldName }
     *     
     */
    public FieldName getWeightField() {
        return weightField;
    }

    /**
     * Sets the value of the weightField property.
     * 
     * @param value
     *     allowed object is
     *     {@link FieldName }
     *     
     */
    public void setWeightField(FieldName value) {
        this.weightField = value;
    }

    /**
     * Gets the value of the normalizationScheme property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getNormalizationScheme() {
        return normalizationScheme;
    }

    /**
     * Sets the value of the normalizationScheme property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setNormalizationScheme(String value) {
        this.normalizationScheme = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof TestDistributions)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        if (!super.equals(thisLocator, thatLocator, object, strategy)) {
            return false;
        }
        final TestDistributions that = ((TestDistributions) object);
        {
            Baseline lhsBaseline;
            lhsBaseline = this.getBaseline();
            Baseline rhsBaseline;
            rhsBaseline = that.getBaseline();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "baseline", lhsBaseline), LocatorUtils.property(thatLocator, "baseline", rhsBaseline), lhsBaseline, rhsBaseline)) {
                return false;
            }
        }
        {
            Alternate lhsAlternate;
            lhsAlternate = this.getAlternate();
            Alternate rhsAlternate;
            rhsAlternate = that.getAlternate();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "alternate", lhsAlternate), LocatorUtils.property(thatLocator, "alternate", rhsAlternate), lhsAlternate, rhsAlternate)) {
                return false;
            }
        }
        {
            List<Extension> lhsExtensions;
            lhsExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            List<Extension> rhsExtensions;
            rhsExtensions = (((that.extensions!= null)&&(!that.extensions.isEmpty()))?that.getExtensions():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "extensions", lhsExtensions), LocatorUtils.property(thatLocator, "extensions", rhsExtensions), lhsExtensions, rhsExtensions)) {
                return false;
            }
        }
        {
            FieldName lhsField;
            lhsField = this.getField();
            FieldName rhsField;
            rhsField = that.getField();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "field", lhsField), LocatorUtils.property(thatLocator, "field", rhsField), lhsField, rhsField)) {
                return false;
            }
        }
        {
            BaselineTestStatisticType lhsTestStatistic;
            lhsTestStatistic = this.getTestStatistic();
            BaselineTestStatisticType rhsTestStatistic;
            rhsTestStatistic = that.getTestStatistic();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "testStatistic", lhsTestStatistic), LocatorUtils.property(thatLocator, "testStatistic", rhsTestStatistic), lhsTestStatistic, rhsTestStatistic)) {
                return false;
            }
        }
        {
            double lhsResetValue;
            lhsResetValue = ((this.resetValue!= null)?this.getResetValue(): 0.0D);
            double rhsResetValue;
            rhsResetValue = ((that.resetValue!= null)?that.getResetValue(): 0.0D);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "resetValue", lhsResetValue), LocatorUtils.property(thatLocator, "resetValue", rhsResetValue), lhsResetValue, rhsResetValue)) {
                return false;
            }
        }
        {
            BigInteger lhsWindowSize;
            lhsWindowSize = this.getWindowSize();
            BigInteger rhsWindowSize;
            rhsWindowSize = that.getWindowSize();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "windowSize", lhsWindowSize), LocatorUtils.property(thatLocator, "windowSize", rhsWindowSize), lhsWindowSize, rhsWindowSize)) {
                return false;
            }
        }
        {
            FieldName lhsWeightField;
            lhsWeightField = this.getWeightField();
            FieldName rhsWeightField;
            rhsWeightField = that.getWeightField();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "weightField", lhsWeightField), LocatorUtils.property(thatLocator, "weightField", rhsWeightField), lhsWeightField, rhsWeightField)) {
                return false;
            }
        }
        {
            String lhsNormalizationScheme;
            lhsNormalizationScheme = this.getNormalizationScheme();
            String rhsNormalizationScheme;
            rhsNormalizationScheme = that.getNormalizationScheme();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "normalizationScheme", lhsNormalizationScheme), LocatorUtils.property(thatLocator, "normalizationScheme", rhsNormalizationScheme), lhsNormalizationScheme, rhsNormalizationScheme)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = super.hashCode(locator, strategy);
        {
            Baseline theBaseline;
            theBaseline = this.getBaseline();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "baseline", theBaseline), currentHashCode, theBaseline);
        }
        {
            Alternate theAlternate;
            theAlternate = this.getAlternate();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "alternate", theAlternate), currentHashCode, theAlternate);
        }
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "extensions", theExtensions), currentHashCode, theExtensions);
        }
        {
            FieldName theField;
            theField = this.getField();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "field", theField), currentHashCode, theField);
        }
        {
            BaselineTestStatisticType theTestStatistic;
            theTestStatistic = this.getTestStatistic();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "testStatistic", theTestStatistic), currentHashCode, theTestStatistic);
        }
        {
            double theResetValue;
            theResetValue = ((this.resetValue!= null)?this.getResetValue(): 0.0D);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "resetValue", theResetValue), currentHashCode, theResetValue);
        }
        {
            BigInteger theWindowSize;
            theWindowSize = this.getWindowSize();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "windowSize", theWindowSize), currentHashCode, theWindowSize);
        }
        {
            FieldName theWeightField;
            theWeightField = this.getWeightField();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "weightField", theWeightField), currentHashCode, theWeightField);
        }
        {
            String theNormalizationScheme;
            theNormalizationScheme = this.getNormalizationScheme();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "normalizationScheme", theNormalizationScheme), currentHashCode, theNormalizationScheme);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        super.appendFields(locator, buffer, strategy);
        {
            Baseline theBaseline;
            theBaseline = this.getBaseline();
            strategy.appendField(locator, this, "baseline", buffer, theBaseline);
        }
        {
            Alternate theAlternate;
            theAlternate = this.getAlternate();
            strategy.appendField(locator, this, "alternate", buffer, theAlternate);
        }
        {
            List<Extension> theExtensions;
            theExtensions = (((this.extensions!= null)&&(!this.extensions.isEmpty()))?this.getExtensions():null);
            strategy.appendField(locator, this, "extensions", buffer, theExtensions);
        }
        {
            FieldName theField;
            theField = this.getField();
            strategy.appendField(locator, this, "field", buffer, theField);
        }
        {
            BaselineTestStatisticType theTestStatistic;
            theTestStatistic = this.getTestStatistic();
            strategy.appendField(locator, this, "testStatistic", buffer, theTestStatistic);
        }
        {
            double theResetValue;
            theResetValue = ((this.resetValue!= null)?this.getResetValue(): 0.0D);
            strategy.appendField(locator, this, "resetValue", buffer, theResetValue);
        }
        {
            BigInteger theWindowSize;
            theWindowSize = this.getWindowSize();
            strategy.appendField(locator, this, "windowSize", buffer, theWindowSize);
        }
        {
            FieldName theWeightField;
            theWeightField = this.getWeightField();
            strategy.appendField(locator, this, "weightField", buffer, theWeightField);
        }
        {
            String theNormalizationScheme;
            theNormalizationScheme = this.getNormalizationScheme();
            strategy.appendField(locator, this, "normalizationScheme", buffer, theNormalizationScheme);
        }
        return buffer;
    }

}
